import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Arrays;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ProxyDemo {
    public static String ProxyUrl = "代理IP地址";
    public static String methodUrl = "http://www.net.cn/static/customercare/yourip.asp";

    public static void main(String[] args) {
        String[] proxyArr = ProxyDemo.getProxy();
        String host = proxyArr[0];
        String port = proxyArr[1];
        setProxy(host, port);
        HttpURLConnection connection = null;
        BufferedReader reader = null;
        String line = null;
        try {
            URL url = new URL(ProxyDemo.methodUrl);
            connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod("GET");
            connection.connect();
            if (connection.getResponseCode() == HttpURLConnection.HTTP_OK) {
                reader = new BufferedReader(new InputStreamReader(connection.getInputStream(), "utf-8"));
                StringBuilder result = new StringBuilder();
                while ((line = reader.readLine()) != null) {
                    result.append(line).append(System.getProperty("line.separator"));// "\n"
                }
                String htmlStr = result.toString();
                System.out.println(htmlStr);
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                reader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            connection.disconnect();
        }
    }

    public static String[] getProxy() {
        String methodUrl = ProxyDemo.ProxyUrl;
        HttpURLConnection connection = null;
        BufferedReader reader = null;
        String line = null;
        String proxyStr = null;
        try {
            URL url = new URL(methodUrl);
            connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod("GET");
            connection.connect();
            if (connection.getResponseCode() == HttpURLConnection.HTTP_OK) {
                reader = new BufferedReader(new InputStreamReader(connection.getInputStream(), "UTF8"));
                StringBuilder result = new StringBuilder();
                while ((line = reader.readLine()) != null) {
                    result.append(line).append(System.getProperty("line.separator"));
                }
                proxyStr = result.toString();
                String[] proxyArr = new String[0];
                if (proxyStr != null) {
                    Pattern p = Pattern.compile("\\s*|\t|\r|\n");
                    Matcher m = p.matcher(proxyStr);
                    String dest = m.replaceAll("");
                    proxyArr = dest.split(":");
                    System.out.println(Arrays.toString(proxyArr));
                    return proxyArr;
                } else {
                    if (proxyArr.length == 0) {
                        System.out.println("获取代理IP失败");
                    }
                }

            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                reader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            connection.disconnect();
        }
        return null;
    }

    public static void setProxy(String host, String port) {
        System.setProperty("proxySet", "true");
        System.setProperty("proxyHost", host);
        System.setProperty("proxyPort", port);
    }
}
